// https://forex-station.com/viewtopic.php?p=1295413674#p1295413674
// modified by banzai; 6/29/20
// thanks to jeanlouie codes and templates @ https://www.forexfactory.com/jeanlouie

#property copyright "Alexander Elgin"
#property link      "alexmost113@mail.ru"
#property indicator_chart_window

/*
#property indicator_buffers 5
#property indicator_color1 clrGreen
#property indicator_color2 clrDodgerBlue
#property indicator_color3 clrDarkOrange
#property indicator_color4 clrRed
#property indicator_color5 clrPurple
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_SOLID
#property indicator_style4 STYLE_SOLID
#property indicator_style5 STYLE_SOLID
*/

#define PERIODS_NUMBER 5
#define INDICATOR_NAME "Fractal Support Resistance"
#define SUPPORT "support"
#define RESISTANCE "resistance"
#define BAR_TO_START_SCAN_FROM 2

//template code start1
extern string              note1                = "------------------------------";
extern color               H1Color              = clrGreen;
extern color               H4Color              = clrDodgerBlue;
extern color               D1Color              = clrDarkOrange;
extern color               W1Color              = clrRed;
extern color               MN1Color             = clrPurple;
extern string              note2                = "------------------------------";
extern ENUM_LINE_STYLE     H1LineStyle          = STYLE_DOT;
extern ENUM_LINE_STYLE     H4LineStyle          = STYLE_DOT;
extern ENUM_LINE_STYLE     D1LineStyle          = STYLE_SOLID;
extern ENUM_LINE_STYLE     W1LineStyle          = STYLE_SOLID;
extern ENUM_LINE_STYLE     MN1LineStyle         = STYLE_SOLID;
extern string              note3                = "------------------------------";
extern int                 H1LineWidth          = 1;
extern int                 H4LineWidth          = 1;
extern int                 D1LineWidth          = 1;
extern int                 W1LineWidth          = 1;
extern int                 MN1LineWidth         = 1;
extern string              note4                = "------------------------------";
extern bool                btn_show             = true;                         //btn__show
extern ENUM_BASE_CORNER    btn_corner           = CORNER_LEFT_UPPER; // chart corner for anchoring
extern string              btn_pressed          = "S&R";                //btn__pressed text
extern string              btn_unpressed        = "S&R";              //btn__unpressed text
extern int                 btn_offset_x         = 20;                             //btn__x
extern int                 btn_offset_y         = 20;                              //btn__y
extern int                 btn_width            = 60;                          //btn__width
extern int                 btn_height           = 20;                         //btn__height
extern int                 btn_font_size        = 10;                      //btn__font size
extern color               btn_font_clr         = clrBlack;               //btn__font color
extern color               btn_bg_color         = clrGray;                  //btn__bg color
extern color               btn_border_clr       = clrWhiteSmoke;        //btn__border color
extern string              note5                = "------------------------------";
//template code end1

int timeframes[PERIODS_NUMBER] = {PERIOD_H1, PERIOD_H4, PERIOD_D1, PERIOD_W1, PERIOD_MN1};

//template code start2
//int styles[PERIODS_NUMBER] = {indicator_style1, indicator_style2, indicator_style3, indicator_style4, indicator_style5};
//color colors[PERIODS_NUMBER] = {indicator_color1, indicator_color2, indicator_color3, indicator_color4, indicator_color5};
   int   styles[5];
   color colors[5];
   int   widths[5];
   string aButtonName = "FractalSR_button";
//template code end2
//+---------------------------------------------------------------------+
int OnInit() {

//template code start3  
   if(btn_show){CreateButton();}
   if(!btn_show){ObjectDelete(0,aButtonName);}
   colors[0] = H1Color;
   colors[1] = H4Color;
   colors[2] = D1Color;
   colors[3] = W1Color;
   colors[4] = MN1Color;
   
   styles[0] = H1LineStyle;
   styles[1] = H4LineStyle;
   styles[2] = D1LineStyle;
   styles[3] = W1LineStyle;
   styles[4] = MN1LineStyle;

   widths[0] = H1LineWidth;
   widths[1] = H4LineWidth;
   widths[2] = D1LineWidth;
   widths[3] = W1LineWidth;
   widths[4] = MN1LineWidth;   
//template code end3

	IndicatorShortName(INDICATOR_NAME);
	return(0);
}
//+---------------------------------------------------------------------+
int deinit() {
	string object_types[2] = {SUPPORT, RESISTANCE};
	
   //template code start4
   ObjectDelete(0,aButtonName);
   //template code end4

	for(int timeframe_index = 0; timeframe_index < ArraySize(timeframes); timeframe_index++)
		for(int object_type_index = 0; object_type_index < ArraySize(object_types); object_type_index++)
			ObjectDelete(getTrendLineName(object_types[object_type_index], timeframes[timeframe_index]));
			
	return(0);
}
//+---------------------------------------------------------------------+
int start() 
{
//template code start5
if(!ObjectGetInteger(0,aButtonName,OBJPROP_STATE))
       {
//template code end5
    
	     for (int timeframe_index = 0; timeframe_index < ArraySize(timeframes); timeframe_index++) 
	         {
	         	if (Period() <= timeframes[timeframe_index]) 
	         	{
			        drawResistance(getUpperFractalBar(timeframes[timeframe_index], BAR_TO_START_SCAN_FROM), timeframe_index);
			        drawSupport   (getLowerFractalBar(timeframes[timeframe_index], BAR_TO_START_SCAN_FROM), timeframe_index);
		         }
		      }
	    }
	return(0);
}
//+---------------------------------------------------------------------+
int getUpperFractalBar(int timeframe, int starting_bar) {
	for(int bar = starting_bar; bar < Bars; bar++)
		if(isUpperFractal(timeframe, bar)) return(bar);
	return (-1);
}
//+---------------------------------------------------------------------+
bool isUpperFractal(int timeframe, int bar) {
	for(int offset = -2; offset <= 2; offset++)
		if( (offset != 0) && (iHigh(Symbol(), timeframe, bar + offset) > iHigh(Symbol(), timeframe, bar)) ) return(false);
	return (true);
}
//+---------------------------------------------------------------------+
int getLowerFractalBar(int timeframe, int starting_bar) {
	for(int bar = starting_bar; bar < Bars; bar++)
		if(isLowerFractal(timeframe, bar)) return(bar);
	return (-1);
}
//+---------------------------------------------------------------------+
bool isLowerFractal(int timeframe, int bar) {
	for(int offset = -2; offset <= 2; offset++)
		if( (offset != 0) && (iLow(Symbol(), timeframe, bar + offset) < iLow(Symbol(), timeframe, bar)) ) return(false);
	return (true);
}
//+---------------------------------------------------------------------+
void drawResistance(int bar_index, int timeframe_index) {
	if(bar_index > 0) drawTrendLine(getTrendLineName(RESISTANCE, timeframes[timeframe_index]), iHigh(Symbol(), timeframes[timeframe_index], bar_index), colors[timeframe_index], styles[timeframe_index], widths[timeframe_index]);
}
//+---------------------------------------------------------------------+
void drawSupport(int bar_index, int timeframe_index) {
	if(bar_index > 0) drawTrendLine(getTrendLineName(SUPPORT,    timeframes[timeframe_index]), iLow(Symbol(), timeframes[timeframe_index], bar_index), colors[timeframe_index], styles[timeframe_index], widths[timeframe_index]);
}
//+---------------------------------------------------------------------+
void drawTrendLine(string object_name, double price, color line_color, int line_style, int line_width) {
	ObjectDelete(object_name);
	ObjectCreate(object_name, OBJ_HLINE, 0, Time[0], price, Time[Bars - 1], price);
	ObjectSet   (object_name, OBJPROP_COLOR, line_color);
	ObjectSet   (object_name, OBJPROP_STYLE, line_style);
	ObjectSet   (object_name, OBJPROP_WIDTH, line_width);	
}
//+---------------------------------------------------------------------+
string getTrendLineName(string object_type, int timeframe) {
	return(object_type + getTimeframeName(timeframe));
}
//+---------------------------------------------------------------------+
string getTimeframeName(int timeframe) {
	static int timeframe_periods[] = {PERIOD_M1, PERIOD_M5, PERIOD_M15, PERIOD_M30, PERIOD_H1, PERIOD_H4, PERIOD_D1, PERIOD_W1, PERIOD_MN1};
	static string timeframe_names[] = {"M1", "M5", "M15", "M30", "H1", "H4", "D1", "W1", "MN1"};
	
	for(int i = 0; i < ArraySize(timeframe_periods); i++)
		if(timeframe == timeframe_periods[i]) return (timeframe_names[i]);

	return("Unknown");
}
//+---------------------------------------------------------------------+
//template start codes6
void CreateButton()
{
   ButtonCreate(NULL,aButtonName,0,btn_offset_x,btn_offset_y,btn_width,btn_height,btn_corner,btn_unpressed,"Arial",btn_font_size,btn_font_clr,btn_bg_color,btn_border_clr,false,true,false,false,0);
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
{
   if (id == CHARTEVENT_OBJECT_CLICK && sparam==aButtonName) 
   { 
      if(ObjectGetInteger (0,aButtonName,OBJPROP_STATE)){
          ObjectSetString  (0,aButtonName,OBJPROP_TEXT,btn_pressed);
          string object_types[2] = {SUPPORT, RESISTANCE};
	
	       for(int timeframe_index = 0; timeframe_index < ArraySize(timeframes); timeframe_index++)
		    for(int object_type_index = 0; object_type_index < ArraySize(object_types); object_type_index++)
		    ObjectDelete(getTrendLineName(object_types[object_type_index], timeframes[timeframe_index]));
         }

      if(!ObjectGetInteger(0,aButtonName,OBJPROP_STATE)){
          ObjectSetString  (0,aButtonName,OBJPROP_TEXT,btn_unpressed);
          start();
         }
   }
}
//+------------------------------------------------------------------+
bool ButtonCreate(const long              chart_ID   = 0,               // chart's ID
                  const string            name       = "Button",            // button name
                  const int               sub_window = 0,             // subwindow index
                  const int               x          = 0,                      // X coordinate
                  const int               y          = 0,                      // Y coordinate
                  const int               width      = 50,                 // button width
                  const int               height     = 18,                // button height
                  const int               mycorner   = CORNER_LEFT_UPPER,
                  const string            text       = "Button",            // text
                  const string            font       = "Arial",             // font
                  const int               font_size  = 10,             // font size
                  const color             clr        = clrBlack,             // text color
                  const color             back_clr   = C'236,233,216',  // background color
                  const color             border_clr = clrNONE,       // border color
                  const bool              state      = false,              // pressed/released
                  const bool              back       = false,               // in the background
                  const bool              selectable = true,      //object can be selected        
                  const bool              selection  = false,          // highlight to move
                  const bool              hidden     = false,              // hidden in the object list
                  const long              z_order    = 0)                // priority for mouse click
  {
   ResetLastError();
   ObjectCreate    (chart_ID,name,OBJ_BUTTON,          sub_window,0,0);
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,   x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,   y);
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,       width);
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,      mycorner);
   ObjectSetString (chart_ID,name,OBJPROP_TEXT,        text);
   ObjectSetString (chart_ID,name,OBJPROP_FONT,        font);
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,    font_size);
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,       clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,     back_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,        back);
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,       state);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,  selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,    selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,      hidden);
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,      z_order);
   return(true);
  }
//+------------------------------------------------------------------+
//template end codes6
